import asyncio
from fastapi import Form
from fastapi.responses import JSONResponse
from asyncio import to_thread
from pipeline_setup import pipe

async def text_query(question: str = Form(...)):
    """
    API endpoint to process text input with the user's query.
    """
    try:
        response = await asyncio.to_thread(pipe, question)
        return JSONResponse({"query": question, "response": response.text})
    except Exception as e:
        return JSONResponse({"query": question, "error": str(e)})

# async def text_query(question: str = Form(...)):
#     """
#     API endpoint to process text input with the user's query.
#     """
#     try:
#         response = await to_thread(pipe, question)
#         return {"query": question, "response": response.text}
#     except Exception as e:
#         return {"query": question, "error": str(e)}
